Add Row and Column Buttons

Rows and columns can be added with a button at the end of the row and column headers in a worksheet.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

SpreadJS allows you to add a row or column through a self-defined button to the worksheet.

It could show or hide the add row or column button:

    // show the add row button
    sheet.options.addRowButtonOption.visible = true;
    // show the add column button
    sheet.options.addColumnButtonOption.visible = true;

And it could specify the width, height, style and tooltip for the button, the add row button option only support the height property, the add column button only support the width property, and it just support some simple properties of the style like foreColor, backColor, hAlign, vAlign, backgroundImage, backgroundImageLayout to paint on the worksheet.

    sheet.options.addRowButtonOption.height = 30;
    sheet.options.addRowButtonOption.tooltip = 'Add Row';
    var style = new GC.Spread.Sheets.Style();
    style.backColor = 'white';
    style.foreColor = 'black';
    sheet.options.addRowButtonOption.style = style;

    sheet.options.addColumnButtonOption.width = 30;
    sheet.options.addColumnButtonOption.tooltip = 'Add Column';
    var style = new GC.Spread.Sheets.Style();
    style.backColor = 'gray';
    style.foreColor = 'red';
    sheet.options.addColumnButtonOption.style = style;

If it's necessary to self define the actions of the buttons, it could specify the command to each button:

    spread.commandManager().register('clickRowButtonToDo', {
        canUndo: false,
        execute: function (context, options) {
            // the self-defined command
        }
    });
    sheet.options.addRowButtonOption.command = 'clickRowButtonToDo';
    spread.commandManager().register('clickColumnButtonToDo', {
        canUndo: false,
        execute: function (context, options) {
            // the self-defined command
        }
    });
    sheet.options.addColumnButtonOption.command = 'clickColumnButtonToDo';
SpreadJS allows you to add a row or column through a self-defined button to the worksheet. It could show or hide the add row or column button: And it could specify the width, height, style and tooltip for the button, the add row button option only support the height property, the add column button only support the width property, and it just support some simple properties of the style like foreColor, backColor, hAlign, vAlign, backgroundImage, backgroundImageLayout to paint on the worksheet. If it's necessary to self define the actions of the buttons, it could specify the command to each button:
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss")); var spreadNS = GC.Spread.Sheets; var sheet = spread.getSheet(0); sheet.suspendPaint(); sheet.options.addRowButtonOption.visible = true; sheet.options.addColumnButtonOption.visible = true; sheet.setRowCount(10); sheet.setColumnCount(10); sheet.resumePaint(); /* * Show or hide the add row/column button. */ _getElementById("columnBtnVisible").addEventListener('click',function () { var sheet = spread.getActiveSheet(); sheet.options.addColumnButtonOption.visible = this.checked; spread.repaint(); }); _getElementById("rowBtnVisible").addEventListener('click',function () { var sheet = spread.getActiveSheet(); sheet.options.addRowButtonOption.visible = this.checked; spread.repaint(); }); /* * Update the width/height of the add row/column button. */ _getElementById("columnBtnWidth").addEventListener('change',function () { var sheet = spread.getActiveSheet(); sheet.options.addColumnButtonOption.width = parseInt(this.value); spread.repaint(); }); _getElementById("rowBtnHeight").addEventListener('change',function () { var sheet = spread.getActiveSheet(); sheet.options.addRowButtonOption.height = parseInt(this.value); spread.repaint(); }); /* * Update the tooltip of the add row/column button. */ _getElementById("columnBtnTooltip").addEventListener('input',function () { var sheet = spread.getActiveSheet(); sheet.options.addColumnButtonOption.tooltip = this.value; spread.repaint(); }); _getElementById("rowBtnTooltip").addEventListener('input',function () { var sheet = spread.getActiveSheet(); sheet.options.addRowButtonOption.tooltip = this.value; spread.repaint(); }); /* * Update the style of the add row/column button. */ _getElementById("columnBtnBackColor").addEventListener('input',function () { var sheet = spread.getActiveSheet(); var style = new GC.Spread.Sheets.Style(); style.backColor = this.value; style.vAlign = GC.Spread.Sheets.VerticalAlign.center; style.hAlign = GC.Spread.Sheets.HorizontalAlign.center; sheet.options.addColumnButtonOption.style = style; spread.repaint(); }); _getElementById("rowBtnBackColor").addEventListener('input',function () { var sheet = spread.getActiveSheet(); var style = new GC.Spread.Sheets.Style(); style.backColor = this.value; style.vAlign = GC.Spread.Sheets.VerticalAlign.center; style.hAlign = GC.Spread.Sheets.HorizontalAlign.center; sheet.options.addRowButtonOption.style = style; spread.repaint(); }); // Define the command const addRowCommand = sheet.options.addRowButtonOption.command; spread.commandManager().register('clickRowButtonToDo', { canUndo: false, execute: function (context, options) { // the self-defined command options.cmd = addRowCommand; spread.commandManager().execute(options); } }); sheet.options.addRowButtonOption.command = 'clickRowButtonToDo'; const addColumnCommand = sheet.options.addColumnButtonOption.command; spread.commandManager().register('clickColumnButtonToDo', { canUndo: false, execute: function (context, options) { // the self-defined command options.cmd = addColumnCommand; spread.commandManager().execute(options); } }); sheet.options.addColumnButtonOption.command = 'clickColumnButtonToDo'; }; function _getElementById(id) { return document.getElementById(id); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <label>Set the options below to show the add column/row button.</label> <div class="option-row"> <input type="checkbox" id="columnBtnVisible" checked /> <label class="checkbox-label" for="columnBtnVisible">Add Column Button Visible</label> </div> <div class="option-row"> <input type="checkbox" id="rowBtnVisible" checked /> <label class="checkbox-label" for="rowBtnVisible">Add Row Button Visible</label> </div> <hr> <div class="option-row"> <label >Set the width/height to the add column/row button.</label> </div> <div class="option-row"> <label for="columnBtnWidth">Add Column Button Width</label> <input type="number" value="62" id="columnBtnWidth" /> <label for="rowBtnHeight">Add Row Button Height</label> <input type="number" value="20" id="rowBtnHeight" /> </div> <hr> <div class="option-row"> <label >Set the tooltip to the add column/row button.</label> </div> <div class="option-row"> <label for="columnBtnTooltip">Add Column Button Tooltip</label> <input type="text" value="" id="columnBtnTooltip" /> <label for="rowBtnTooltip">Add Row Button Tooltip</label> <input type="text" value="" id="rowBtnTooltip" /> </div> <hr> <div class="option-row"> <label >Set the back color to the add column/row button.</label> </div> <div class="option-row"> <label for="columnBtnBackColor">Add Column Button Back Color</label> <input type="color" value="" id="columnBtnBackColor" /> <label for="rowBtnBackColor">Add Row Button Back Color</label> <input type="color" value="" id="rowBtnBackColor" /> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; } label { margin-bottom: 6px; display: block; margin-top: 10px; } .checkbox-label { display: inline; } input[type=button] { margin-top: 6px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

SpreadJS allows you to add a row or column through a self-defined button to the worksheet.
It could show or hide the add row or column button:
And it could specify the width, height, style and tooltip for the button, the add row button option only support the height property, the add column button only support the width property, and it just support some simple properties of the style like foreColor, backColor, hAlign, vAlign, backgroundImage, backgroundImageLayout to paint on the worksheet.
If it's necessary to self define the actions of the buttons, it could specify the command to each button:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
headerAutoTextType: any;
headerType: string;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
let spread = this.spread = $event.spread;
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.addRowButtonOption.visible = true;
sheet.options.addColumnButtonOption.visible = true;
sheet.setRowCount(10);
sheet.setColumnCount(10);
// Define the command
const addRowCommand = sheet.options.addRowButtonOption.command;
spread.commandManager().register('clickRowButtonToDo', {
canUndo: false,
execute: function (context, options) {
// the self-defined command
options.cmd = addRowCommand;
spread.commandManager().execute(options);
}
});
sheet.options.addRowButtonOption.command = 'clickRowButtonToDo';
const addColumnCommand = sheet.options.addColumnButtonOption.command;
spread.commandManager().register('clickColumnButtonToDo', {
canUndo: false,
execute: function (context, options) {
// the self-defined command
options.cmd = addColumnCommand;
spread.commandManager().execute(options);
}
});
sheet.options.addColumnButtonOption.command = 'clickColumnButtonToDo';
sheet.resumePaint();
}
columnBtnVisible($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.visible = $event.target.checked;
spread.repaint();
}
rowBtnVisible($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.visible = $event.target.checked;
spread.repaint();
}
columnBtnWidth($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.width = parseInt($event.target.value);
spread.repaint();
}
rowBtnHeight($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.height = parseInt($event.target.value);
spread.repaint();
}
columnBtnTooltip($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.tooltip = $event.target.value;
spread.repaint();
}
rowBtnTooltip($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.tooltip = $event.target.value;
spread.repaint();
}
columnBtnBackColor($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
var style = new GC.Spread.Sheets.Style();
style.backColor = $event.target.value;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
sheet.options.addColumnButtonOption.style = style;
spread.repaint();
}
rowBtnBackColor($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
var style = new GC.Spread.Sheets.Style();
style.backColor = $event.target.value;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
sheet.options.addRowButtonOption.style = style;
spread.repaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<label>Set the options below to show the add column/row button.</label>
<div class="option-row">
<input type="checkbox" id="columnBtnVisible" checked (change)="columnBtnVisible($event)" />
<label class="checkbox-label" for="columnBtnVisible">Add Column Button Visible</label>
</div>
<div class="option-row">
<input type="checkbox" id="rowBtnVisible" checked (change)="rowBtnVisible($event)" />
<label class="checkbox-label" for="rowBtnVisible">Add Row Button Visible</label>
</div>
<hr>
<div class="option-row">
<label >Set the width/height to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnWidth">Add Column Button Width</label>
<input type="number" value="62" id="columnBtnWidth" (change)="columnBtnWidth($event)" />
<label for="rowBtnHeight">Add Row Button Height</label>
<input type="number" value="20" id="rowBtnHeight" (change)="rowBtnHeight($event)" />
</div>
<hr>
<div class="option-row">
<label >Set the tooltip to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnTooltip">Add Column Button Tooltip</label>
<input type="text" value="" id="columnBtnTooltip" (change)="columnBtnTooltip($event)" />
<label for="rowBtnTooltip">Add Row Button Tooltip</label>
<input type="text" value="" id="rowBtnTooltip" (change)="rowBtnTooltip($event)" />
</div>
<hr>
<div class="option-row">
<label >Set the back color to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnBackColor">Add Column Button Back Color</label>
<input type="color" value="" id="columnBtnBackColor" (change)="columnBtnBackColor($event)" />
<label for="rowBtnBackColor">Add Row Button Back Color</label>
<input type="color" value="" id="rowBtnBackColor" (change)="rowBtnBackColor($event)" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
}
label {
margin-bottom: 6px;
display: block;
margin-top: 10px;
}
.checkbox-label {
display: inline;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib': 'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

SpreadJS allows you to add a row or column through a self-defined button to the worksheet.
It could show or hide the add row or column button:
And it could specify the width, height, style and tooltip for the button, the add row button option only support the height property, the add column button only support the width property, and it just support some simple properties of the style like foreColor, backColor, hAlign, vAlign, backgroundImage, backgroundImageLayout to paint on the worksheet.
If it's necessary to self define the actions of the buttons, it could specify the command to each button:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<label>Set the options below to show the add column/row button.</label>
<div class="option-row">
<input type="checkbox" id="columnBtnVisible" checked @change="columnBtnVisible" />
<label class="checkbox-label" for="columnBtnVisible">Add Column Button Visible</label>
</div>
<div class="option-row">
<input type="checkbox" id="rowBtnVisible" checked @change="rowBtnVisible" />
<label class="checkbox-label" for="rowBtnVisible">Add Row Button Visible</label>
</div>
<hr>
<div class="option-row">
<label>Set the width/height to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnWidth">Add Column Button Width</label>
<input type="number" value="62" id="columnBtnWidth" @change="columnBtnWidth" />
<label for="rowBtnHeight">Add Row Button Height</label>
<input type="number" value="20" id="rowBtnHeight" @change="rowBtnHeight" />
</div>
<hr>
<div class="option-row">
<label>Set the tooltip to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnTooltip">Add Column Button Tooltip</label>
<input type="text" value="" id="columnBtnTooltip" @change="columnBtnTooltip" />
<label for="rowBtnTooltip">Add Row Button Tooltip</label>
<input type="text" value="" id="rowBtnTooltip" @change="rowBtnTooltip" />
</div>
<hr>
<div class="option-row">
<label>Set the back color to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnBackColor">Add Column Button Back Color</label>
<input type="color" value="" id="columnBtnBackColor" @change="columnBtnBackColor" />
<label for="rowBtnBackColor">Add Row Button Back Color</label>
<input type="color" value="" id="rowBtnBackColor" @change="rowBtnBackColor" />
</div>
</div>
</div>
</template>
<script setup>
import GC from '@mescius/spread-sheets';
import { ref, watch } from "vue";
import "@mescius/spread-sheets-vue";
const spreadRef = ref(null);
let initSpread = async function (spread) {
spreadRef.value = spread;
var sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.addRowButtonOption.visible = true;
sheet.options.addColumnButtonOption.visible = true;
sheet.setRowCount(10);
sheet.setColumnCount(10);
sheet.resumePaint();
// Define the command
const addRowCommand = sheet.options.addRowButtonOption.command;
spread.commandManager().register('clickRowButtonToDo', {
canUndo: false,
execute: function (context, options) {
// the self-defined command
options.cmd = addRowCommand;
spread.commandManager().execute(options);
}
});
sheet.options.addRowButtonOption.command = 'clickRowButtonToDo';
const addColumnCommand = sheet.options.addColumnButtonOption.command;
spread.commandManager().register('clickColumnButtonToDo', {
canUndo: false,
execute: function (context, options) {
// the self-defined command
options.cmd = addColumnCommand;
spread.commandManager().execute(options);
}
});
sheet.options.addColumnButtonOption.command = 'clickColumnButtonToDo';
}
function columnBtnVisible($event) {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.visible = $event.target.checked;
spread.repaint();
}
function rowBtnVisible($event) {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.visible = $event.target.checked;
spread.repaint();
}
function columnBtnWidth($event) {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.width = parseInt($event.target.value);
spread.repaint();
}
function rowBtnHeight($event) {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.height = parseInt($event.target.value);
spread.repaint();
}
function columnBtnTooltip($event) {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.tooltip = $event.target.value;
spread.repaint();
}
function rowBtnTooltip($event) {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.tooltip = $event.target.value;
spread.repaint();
}
function columnBtnBackColor($event) {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
var style = new GC.Spread.Sheets.Style();
style.backColor = $event.target.value;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
sheet.options.addColumnButtonOption.style = style;
spread.repaint();
}
function rowBtnBackColor($event) {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
var style = new GC.Spread.Sheets.Style();
style.backColor = $event.target.value;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
sheet.options.addRowButtonOption.style = style;
spread.repaint();
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
}
label {
margin-bottom: 6px;
display: block;
margin-top: 10px;
}
.checkbox-label {
display: inline;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

SpreadJS allows you to add a row or column through a self-defined button to the worksheet.
It could show or hide the add row or column button:
And it could specify the width, height, style and tooltip for the button, the add row button option only support the height property, the add column button only support the width property, and it just support some simple properties of the style like foreColor, backColor, hAlign, vAlign, backgroundImage, backgroundImageLayout to paint on the worksheet.
If it's necessary to self define the actions of the buttons, it could specify the command to each button:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const useState = React.useState;
export function AppFunc() {
const [columnBtnVisible, setColumnBtnVisible] = useState(true);
const [rowBtnVisible, setRowBtnVisible] = useState(true);
const [columnBtnWidth, setColumnBtnWidth] = useState(62);
const [rowBtnHeight, setRowBtnHeight] = useState(20);
const [columnBtnTooltip, setColumnBtnTooltip] = useState("");
const [rowBtnTooltip, setRowBtnTooltip] = useState("");
const [columnBtnBackColor, setColumnBtnBackColor] = useState("");
const [rowBtnBackColor, setRowBtnBackColor] = useState("");
const [spread, setSpread] = useState(null);
const initSpread = (spread) => {
setSpread(spread);
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.addRowButtonOption.visible = true;
sheet.options.addColumnButtonOption.visible = true;
sheet.setRowCount(10);
sheet.setColumnCount(10);
sheet.resumePaint();
// Define the command
const addRowCommand = sheet.options.addRowButtonOption.command;
spread.commandManager().register('clickRowButtonToDo', {
canUndo: false,
execute: function (context, options) {
// the self-defined command
options.cmd = addRowCommand;
spread.commandManager().execute(options);
}
});
sheet.options.addRowButtonOption.command = 'clickRowButtonToDo';
const addColumnCommand = sheet.options.addColumnButtonOption.command;
spread.commandManager().register('clickColumnButtonToDo', {
canUndo: false,
execute: function (context, options) {
// the self-defined command
options.cmd = addColumnCommand;
spread.commandManager().execute(options);
}
});
sheet.options.addColumnButtonOption.command = 'clickColumnButtonToDo';
}
const _setColumnBtnVisible = ($event) => {
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.visible = $event.target.checked;
spread.repaint();
setColumnBtnVisible($event.target.checked);
}
const _setRowBtnVisible = ($event) => {
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.visible = $event.target.checked;
spread.repaint();
setRowBtnVisible($event.target.checked);
}
const _setColumnBtnWidth = ($event) => {
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.width = parseInt($event.target.value);
spread.repaint();
setColumnBtnWidth(parseInt($event.target.value));
}
const _setRowBtnHeight = ($event) => {
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.height = parseInt($event.target.value);
spread.repaint();
setRowBtnHeight(parseInt($event.target.value));
}
const _setColumnBtnTooltip = ($event) => {
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.tooltip = $event.target.value;
spread.repaint();
setColumnBtnTooltip($event.target.value);
}
const _setRowBtnTooltip = ($event) => {
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.tooltip = $event.target.value;
spread.repaint();
setRowBtnTooltip($event.target.value);
}
const _setColumnBtnBackColor = ($event) => {
let sheet = spread.getActiveSheet();
var style = new GC.Spread.Sheets.Style();
style.backColor = $event.target.value;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
sheet.options.addColumnButtonOption.style = style;
spread.repaint();
setColumnBtnBackColor($event.target.value);
}
const _setRowBtnBackColor = ($event) => {
let sheet = spread.getActiveSheet();
var style = new GC.Spread.Sheets.Style();
style.backColor = $event.target.value;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
sheet.options.addRowButtonOption.style = style;
spread.repaint();
setRowBtnBackColor($event.target.value);
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<label>Set the options below to show the add column/row button.</label>
<div class="option-row">
<input type="checkbox" id="columnBtnVisible" checked={columnBtnVisible} onChange={(e) => _setColumnBtnVisible(e)} />
<label class="checkbox-label" for="columnBtnVisible">Add Column Button Visible</label>
</div>
<div class="option-row">
<input type="checkbox" id="rowBtnVisible" checked={rowBtnVisible} onChange={(e) => _setRowBtnVisible(e)} />
<label class="checkbox-label" for="rowBtnVisible">Add Row Button Visible</label>
</div>
<hr />
<div class="option-row">
<label >Set the width/height to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnWidth">Add Column Button Width</label>
<input type="number" value={columnBtnWidth} id="columnBtnWidth" onChange={(e) => _setColumnBtnWidth(e)} />
<label for="rowBtnHeight">Add Row Button Height</label>
<input type="number" value={rowBtnHeight} id="rowBtnHeight" onChange={(e) => _setRowBtnHeight(e)} />
</div>
<hr />
<div class="option-row">
<label >Set the tooltip to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnTooltip">Add Column Button Tooltip</label>
<input type="text" value={columnBtnTooltip} id="columnBtnTooltip" onChange={(e) => _setColumnBtnTooltip(e)} />
<label for="rowBtnTooltip">Add Row Button Tooltip</label>
<input type="text" value={rowBtnTooltip} id="rowBtnTooltip" onChange={(e) => _setRowBtnTooltip(e)} />
</div>
<hr />
<div class="option-row">
<label >Set the back color to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnBackColor">Add Column Button Back Color</label>
<input type="color" value={columnBtnBackColor} id="columnBtnBackColor" onChange={(e) => _setColumnBtnBackColor(e)} />
<label for="rowBtnBackColor">Add Row Button Back Color</label>
<input type="color" value={rowBtnBackColor} id="rowBtnBackColor" onChange={(e) => _setRowBtnBackColor(e)} />
</div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
columnBtnVisible: true,
rowBtnVisible: true,
columnBtnWidth: 62,
rowBtnHeight: 20,
columnBtnTooltip: "",
rowBtnTooltip: "",
columnBtnBackColor: "",
rowBtnBackColor: ""
};
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<label>Set the options below to show the add column/row button.</label>
<div class="option-row">
<input type="checkbox" id="columnBtnVisible" checked={this.state.columnBtnVisible} onChange={(e) => this.columnBtnVisible(e)} />
<label class="checkbox-label" for="columnBtnVisible">Add Column Button Visible</label>
</div>
<div class="option-row">
<input type="checkbox" id="rowBtnVisible" checked={this.state.rowBtnVisible} onChange={(e) => this.rowBtnVisible(e)} />
<label class="checkbox-label" for="rowBtnVisible">Add Row Button Visible</label>
</div>
<hr />
<div class="option-row">
<label >Set the width/height to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnWidth">Add Column Button Width</label>
<input type="number" value={this.state.columnBtnWidth} id="columnBtnWidth" onChange={(e) => this.columnBtnWidth(e)} />
<label for="rowBtnHeight">Add Row Button Height</label>
<input type="number" value={this.state.rowBtnHeight} id="rowBtnHeight" onChange={(e) => this.rowBtnHeight(e)} />
</div>
<hr />
<div class="option-row">
<label >Set the tooltip to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnTooltip">Add Column Button Tooltip</label>
<input type="text" value={this.state.columnBtnTooltip} id="columnBtnTooltip" onChange={(e) => this.columnBtnTooltip(e)} />
<label for="rowBtnTooltip">Add Row Button Tooltip</label>
<input type="text" value={this.state.rowBtnTooltip} id="rowBtnTooltip" onChange={(e) => this.rowBtnTooltip(e)} />
</div>
<hr />
<div class="option-row">
<label >Set the back color to the add column/row button.</label>
</div>
<div class="option-row">
<label for="columnBtnBackColor">Add Column Button Back Color</label>
<input type="color" value={this.state.columnBtnBackColor} id="columnBtnBackColor" onChange={(e) => this.columnBtnBackColor(e)} />
<label for="rowBtnBackColor">Add Row Button Back Color</label>
<input type="color" value={this.state.rowBtnBackColor} id="rowBtnBackColor" onChange={(e) => this.rowBtnBackColor(e)} />
</div>
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
let sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.options.addRowButtonOption.visible = true;
sheet.options.addColumnButtonOption.visible = true;
sheet.setRowCount(10);
sheet.setColumnCount(10);
sheet.resumePaint();
// Define the command
const addRowCommand = sheet.options.addRowButtonOption.command;
spread.commandManager().register('clickRowButtonToDo', {
canUndo: false,
execute: function (context, options) {
// the self-defined command
options.cmd = addRowCommand;
spread.commandManager().execute(options);
}
});
sheet.options.addRowButtonOption.command = 'clickRowButtonToDo';
const addColumnCommand = sheet.options.addColumnButtonOption.command;
spread.commandManager().register('clickColumnButtonToDo', {
canUndo: false,
execute: function (context, options) {
// the self-defined command
options.cmd = addColumnCommand;
spread.commandManager().execute(options);
}
});
sheet.options.addColumnButtonOption.command = 'clickColumnButtonToDo';
}
columnBtnVisible($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.visible = $event.target.checked;
spread.repaint();
this.setState({ columnBtnVisible: $event.target.checked });
}
rowBtnVisible($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.visible = $event.target.checked;
spread.repaint();
this.setState({ rowBtnVisible: $event.target.checked });
}
columnBtnWidth($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.width = parseInt($event.target.value);
spread.repaint();
this.setState({ columnBtnWidth: parseInt($event.target.value) });
}
rowBtnHeight($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.height = parseInt($event.target.value);
spread.repaint();
this.setState({ rowBtnHeight: parseInt($event.target.value) });
}
columnBtnTooltip($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addColumnButtonOption.tooltip = $event.target.value;
spread.repaint();
this.setState({ columnBtnTooltip: $event.target.value });
}
rowBtnTooltip($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
sheet.options.addRowButtonOption.tooltip = $event.target.value;
spread.repaint();
this.setState({ rowBtnTooltip: $event.target.value });
}
columnBtnBackColor($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
var style = new GC.Spread.Sheets.Style();
style.backColor = $event.target.value;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
sheet.options.addColumnButtonOption.style = style;
spread.repaint();
this.setState({ columnBtnBackColor: $event.target.value });
}
rowBtnBackColor($event) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
var style = new GC.Spread.Sheets.Style();
style.backColor = $event.target.value;
style.vAlign = GC.Spread.Sheets.VerticalAlign.center;
style.hAlign = GC.Spread.Sheets.HorizontalAlign.center;
sheet.options.addRowButtonOption.style = style;
spread.repaint();
this.setState({ rowBtnBackColor: $event.target.value });
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
position: absolute;
top: 0;
left: 0;
right: 0;
bottom: 0;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
}
label {
margin-bottom: 6px;
display: block;
margin-top: 10px;
}
.checkbox-label {
display: inline;
}
input[type=button] {
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);